=== debian/changelog ===
openshadinglanguage (1.10.9-thomas~bionic9+9.0trisquel1) etiona-backports; urgency=medium

  * Backported from ppa

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 09 Mar 2021 00:42:07 +0000

openshadinglanguage (1.10.9-thomas~bionic9) bionic; urgency=medium

  * New upstream release. Changed OSL include headers location to follow
    blender CMake find_path hints. New oiio.

 -- Thomas Schiex <empnessty@gmail.com>  Mon, 22 Apr 2019 22:32:46 +0100

openshadinglanguage (1.10.4-thomas~bionic3) bionic; urgency=medium

  * New upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Mon, 22 Apr 2019 22:32:46 +0100

openshadinglanguage (1.9.9-thomas~bionic7) bionic; urgency=medium

  * New upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 21 Dec 2018 21:55:46 +0100

openshadinglanguage (1.8.10-thomas~bionic1) bionic; urgency=medium

  * depends on llvm 4.0.

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 03 Sep 2017 16:09:11 +0200

openshadinglanguage (1.8.10-thomas~bionic0) bionic; urgency=medium

  * new upstream release.

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 03 Sep 2017 15:47:40 +0200

openshadinglanguage (1.8-thomas~bionic4) bionic; urgency=medium

  * New upstream version. Compatible with recent LLVM versions.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 25 Mar 2017 01:42:32 +0100

openshadinglanguage (1.7.5-thomas~bionic0) bionic; urgency=medium

  * New upstream version

 -- Thomas Schiex <empnessty@gmail.com>  Sun, 19 Mar 2017 18:59:25 +0100

openshadinglanguage (1.7.3-0thomas~bionic0) bionic; urgency=medium

  * New upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 01 Oct 2016 03:12:31 +0200

openshadinglanguage (1.7.1-0thomas~bionic2) bionic; urgency=medium

  * Dummy change - needed for recompilation with new oiio.

 -- Thomas Schiex <empnessty@gmail.com>  Sat, 13 Feb 2016 14:27:18 +0100

openshadinglanguage (1.7.1-0thomas~bionic0) bionic; urgency=medium

  * New Blender compatible upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 12 Feb 2016 21:42:44 +0100

openshadinglanguage (1.6.8-0thomas~bionic1) bionic; urgency=medium

  * Corrected missing SOVERSION/installed files preventing shlibs:Depends to do its job.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 09 Oct 2015 23:34:20 +0200

openshadinglanguage (1.6.8-0thomas~bionic0) bionic; urgency=medium

  * New upstream version.

 -- Thomas Schiex <empnessty@gmail.com>  Fri, 20 Mar 2015 08:55:13 +0100
