=== debian/control ===
Source: openshadinglanguage
Priority: extra
Maintainer: Thomas Schiex <empnessty@gmail.com>
Build-Depends: debhelper (>= 8.0.0), cmake, chrpath, python3-minimal, python-argparse,
	       flex, bison, llvm-6.0-dev (>= 3.3), clang-6.0 (>= 3.3),
	       libopenexr-dev, libopenimageio-dev, libpng-dev, libtiff5-dev,
	       libboost-filesystem-dev, libboost-regex-dev, libboost-wave-dev, libncurses5-dev,
	       libboost-system-dev, libboost-thread-dev, libtbb-dev, libilmbase-dev,
               zlib1g-dev, libbz2-dev, liblzma-dev, python2.7, python
Standards-Version: 3.9.5
Section: graphics
Homepage: https://github.com/imageworks/OpenShadingLanguage

Package: openshadinglanguage
Architecture: any
Depends: libopenshadinglanguage1.10 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - compiler
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains command line programs such as OSL compiler.

Package: libopenshadinglanguage-dev
Section: libdevel
Architecture: any
Depends: libopenshadinglanguage1.10 (= ${binary:Version}), ${misc:Depends}
Description: Small but rich language for programmable shading - development
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains header files for building programs that provides
 OSL compiler or OSL shading system.

Package: libopenshadinglanguage1.10
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - runtime
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package includes shared libraries and runtime data for
 compiling/running OSL programs.  Also includes example shader scripts.

Package: openshadinglanguage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Small but rich language for programmable shading - document
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains a manual that describes the language specification
 of OSL.
